/*
    Aurorae Designer: an application to design Aurorae themes.
    Copyright (C) 2010  Martin Gräßlin <kde@martin-graesslin.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/

#include "compliancedelegate.h"
#include <QtGui/QApplication>
#include <QtGui/QPainter>

ComplianceDelegate::ComplianceDelegate(QObject *parent)
    : QStyledItemDelegate(parent)
    , m_ok(KIcon("dialog-ok-apply"))
    , m_cancel(KIcon("dialog-cancel"))
{
}

void ComplianceDelegate::paint(QPainter* painter, const QStyleOptionViewItem& option, const QModelIndex& index) const
{
    if (!index.isValid() || index.column() == 0) {
        QStyledItemDelegate::paint(painter, option, index);
    } else {
        QApplication::style()->drawControl( QStyle::CE_ItemViewItem, &option, painter );
        paintIcon(index.model()->data(index).toBool() ? m_ok : m_cancel, painter, option.rect);
    }
}

void ComplianceDelegate::paintIcon(const KIcon &icon, QPainter *painter, const QRect &rect) const
{
    icon.paint(painter, rect, Qt::AlignLeft | Qt::AlignVCenter, QIcon::Normal, QIcon::On);
}

QSize ComplianceDelegate::sizeHint(const QStyleOptionViewItem& option, const QModelIndex& index) const
{
    if (!index.isValid() || index.column() == 0) {
        return QStyledItemDelegate::sizeHint(option, index);
    } else {
        return QSize(20, 20);
    }
}
