/*
    Aurorae Designer: an application to design Aurorae themes.
    Copyright (C) 2010  Martin Gräßlin <kde@martin-graesslin.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/
#include "auroraedesigner.h"
#include <kapplication.h>
#include <kaboutdata.h>
#include <kcmdlineargs.h>
#include <KDE/KLocale>

static const char description[] =
    I18N_NOOP("Designer for Aurorae Themes");

static const char version[] = "0.2.0";

int main(int argc, char **argv)
{
    KAboutData about("auroraedesigner", 0, ki18n("AuroraeDesigner"), version, ki18n(description),
                     KAboutData::License_GPL, ki18n("(C) 2010 Martin Gräßlin"), KLocalizedString(), 0, "kde@martin-graesslin.com");
    about.addAuthor( ki18n("Martin Gräßlin"), KLocalizedString(), "kde@martin-graesslin.com" );
    KCmdLineArgs::init(argc, argv, &about);

    KCmdLineOptions options;
    options.add("+[URL]", ki18n( "Document to open" ));
    KCmdLineArgs::addCmdLineOptions(options);
    KApplication app;

    AuroraeDesigner *widget = new AuroraeDesigner;

    // see if we are starting with session management
    if (app.isSessionRestored())
    {
        RESTORE(AuroraeDesigner);
    }
    else
    {
        // no session.. just start up normally
        KCmdLineArgs *args = KCmdLineArgs::parsedArgs();
        if (args->count() == 0)
        {
            //auroraedesigner *widget = new auroraedesigner;
            widget->show();
        }
        else
        {
            int i = 0;
            for (; i < args->count(); i++)
            {
                //auroraedesigner *widget = new auroraedesigner;
                widget->show();
            }
        }
        args->clear();
    }

    return app.exec();
}
