/*
    Aurorae Designer: an application to design Aurorae themes.
    Copyright (C) 2010  Martin Gräßlin <kde@martin-graesslin.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/

#include "previewdelegate.h"
#include <QtGui/QApplication>
#include <QtGui/QPainter>
#include <QtGui/QPixmap>

PreviewDelegate::PreviewDelegate(QObject *parent)
    : QStyledItemDelegate(parent)
{
}

void PreviewDelegate::paint(QPainter *painter, const QStyleOptionViewItem &option, const QModelIndex &index) const
{
    if (!index.isValid()) {
        QStyledItemDelegate::paint(painter, option, index);
    } else {
        QApplication::style()->drawControl(QStyle::CE_ItemViewItem, &option, painter);
        const QImage &img = index.model()->data(index).value<QImage>();
        const int x = option.rect.x() + (option.rect.width() - img.width())/2;
        const int y = option.rect.y() + (option.rect.height() - img.height())/2;
        painter->drawImage(QRect(x, y, img.width(), img.height()), img);
    }
}

QSize PreviewDelegate::sizeHint(const QStyleOptionViewItem &option, const QModelIndex &index) const
{
    Q_UNUSED(option)
    Q_UNUSED(index)
    return QSize(600, 200);
}
